OGRE: Ogre::SkeletonInstance Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::SkeletonInstance Class Reference

A SkeletonInstance is a single instance of a Skeleton used by a world object. More...

`#include <OgreSkeletonInstance.h>`

Inheritance diagram for Ogre::SkeletonInstance:

[legend]
List of all members.

## Public Types

typedef std::vector< Bone * > | BoneList
typedef VectorIterator< BoneList > | BoneIterator
typedef std::vector< LinkedSkeletonAnimationSource > | LinkedSkeletonAnimSourceList
typedef ConstVectorIterator< LinkedSkeletonAnimSourceList > | LinkedSkeletonAnimSourceIterator
typedef std::vector< ushort > | BoneHandleMap
| Map to translate bone handle from one skeleton to another skeleton.
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions

| SkeletonInstance (const SkeletonPtr &masterCopy)
| Constructor, don't call directly, this will be created automatically when you create an Entity based on a skeletally animated Mesh.
| ~SkeletonInstance ()
unsigned short | getNumAnimations (void) const
| Gets the number of animations on this skeleton.
Animation * | getAnimation (unsigned short index) const
| Gets a single animation by index.
Animation * | _getAnimationImpl (const String &name, const LinkedSkeletonAnimationSource **linker=0) const
| Internal accessor for animations (returns null if animation does not exist).
Animation * | createAnimation (const String &name, Real length)
| Creates a new Animation object for animating this skeleton.
Animation * | getAnimation (const String &name, const LinkedSkeletonAnimationSource **linker=0) const
| Returns the named Animation object.
void | removeAnimation (const String &name)
| Removes an Animation from this skeleton.
TagPoint * | createTagPointOnBone (Bone *bone, const Quaternion &offsetOrientation=Quaternion::IDENTITY, const Vector3 &offsetPosition=Vector3::ZERO)
| Creates a TagPoint ready to be attached to a bone.
void | freeTagPoint (TagPoint *tagPoint)
| Frees a TagPoint that already attached to a bone.
void | addLinkedSkeletonAnimationSource (const String &skelName, Real scale=1.0f)

Remarks:
  If you have skeletons of identical structure (that means identically named bones with identical handles, and with the same hierarchy), but slightly different proportions or binding poses, you can re-use animations from one in the other. Because animations are actually stored as changes to bones from their bind positions, it's possible to use the same animation data for different skeletons, provided the skeletal structure matches and the 'deltas' stored in the keyframes apply equally well to the other skeletons bind position (so they must be roughly similar, but don't have to be identical). You can use the 'scale' option to adjust the translation and scale keyframes where there are large differences in size between the skeletons.

Note:
  This method takes a skeleton name, rather than a more specific animation name, for two reasons; firstly it allows some validation of compatibility of skeletal structure, and secondly skeletons are the unit of loading. Linking a skeleton to another in this way means that the linkee will be prevented from being destroyed until the linker is destroyed.

You cannot set up cyclic relationships, e.g. SkeletonA uses SkeletonB's animations, and SkeletonB uses SkeletonA's animations. This is because it would set up a circular dependency which would prevent proper unloading - make one of the skeletons the 'master' in this case.

Parameters:

  | skelName | Name of the skeleton to link animations from. This skeleton will be loaded immediately if this skeleton is already loaded, otherwise it will be loaded when this skeleton is.
  | scale | A scale factor to apply to translation and scaling elements of the keyframes in the other skeleton when applying the animations to this one. Compensates for skeleton size differences.

void | removeAllLinkedSkeletonAnimationSources (void)
LinkedSkeletonAnimSourceIterator | getLinkedSkeletonAnimationSourceIterator (void) const
void | _initAnimationState (AnimationStateSet *animSet)

Remarks:
  Only recommended for use inside the engine, not by applications.

void | _refreshAnimationState (AnimationStateSet *animSet)

Remarks:
  Only recommended for use inside the engine, not by applications.

const String & | getName (void) const
ResourceHandle | getHandle (void) const
const String & | getGroup (void)
virtual Bone * | createBone (void)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (unsigned short handle)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (const String &name)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (const String &name, unsigned short handle)
| Creates a brand new Bone owned by this Skeleton.
virtual unsigned short | getNumBones (void) const
| Returns the number of bones in this skeleton.
virtual Bone * | getRootBone (void) const
| Gets the root bone of the skeleton: deprecated in favour of getRootBoneIterator.
virtual BoneIterator | getRootBoneIterator (void)
| Get an iterator over the root bones in the skeleton, ie those with no parents.
virtual BoneIterator | getBoneIterator (void)
| Get an iterator over all the bones in the skeleton.
virtual Bone * | getBone (unsigned short handle) const
| Gets a bone by it's handle.
virtual Bone * | getBone (const String &name) const
| Gets a bone by it's name.
virtual void | setBindingPose (void)
| Sets the current position / orientation to be the 'binding pose' ie the layout in which bones were originally bound to a mesh.
virtual void | reset (bool resetManualBones=false)
| Resets the position and orientation of all bones in this skeleton to their original binding position.
virtual bool | hasAnimation (const String &name)
| Returns whether this skeleton contains the named animation.
virtual void | setAnimationState (const AnimationStateSet &animSet)
| Changes the state of the skeleton to reflect the application of the passed in collection of animations.
virtual void | _getBoneMatrices (Matrix4 *pMatrices)
| Populates the passed in array with the bone matrices based on the current position.
virtual SkeletonAnimationBlendMode | getBlendMode () const
| Gets the animation blending mode which this skeleton will use.
virtual void | setBlendMode (SkeletonAnimationBlendMode state)
| Sets the animation blending mode this skeleton will use.
virtual void | _updateTransforms (void)
| Updates all the derived transforms in the skeleton.
virtual void | optimiseAllAnimations (bool preservingIdentityNodeTracks=false)
| Optimise all of this skeleton's animations.
virtual void | _notifyManualBonesDirty (void)
| Internal method for marking the manual bones as dirty.
virtual void | _notifyManualBoneStateChange (Bone *bone)
| Internal method for notifying that a bone is manual.
virtual bool | getManualBonesDirty (void) const
| Have manual bones been modified since the skeleton was last updated?
virtual bool | hasManualBones (void) const
| Are there any manually controlled bones?
virtual void | _mergeSkeletonAnimations (const Skeleton *source, const BoneHandleMap &boneHandleMap, const StringVector &animations=StringVector())
| Merge animations from another Skeleton object into this skeleton.
virtual void | _buildMapBoneByHandle (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
virtual void | _buildMapBoneByName (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
LoadingState | isLoading () const
| Returns whether the resource is currently in the process of background loading.
LoadingState | getLoadingState () const
| Returns the current loading state.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
void | escalateLoading ()
| Escalates the loading of a background loaded resource.
void | addListener (Listener *lis)
| Register a listener on this resource.
void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | _fireBackgroundLoadingComplete (void)
| Firing of background loading complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.

## Static Public Member Functions

static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Protected Types

typedef std::list< TagPoint * > | TagPointList
typedef std::map< String, Bone * > | BoneListByName
| Lookup by bone name.
typedef std::set< Bone * > | BoneSet
typedef std::map< String, Animation * > | AnimationList
| Storage of animations, lookup by name.
typedef std::list< Listener * > | ListenerList

## Protected Member Functions

void | cloneBoneAndChildren (Bone *source, Bone *parent)
void | loadImpl (void)
| Overridden from Skeleton.
void | unloadImpl (void)
| Overridden from Skeleton.
void | deriveRootBone (void) const
| Internal method which parses the bones to derive the root bone.
void | _dumpContents (const String &filename)
| Debugging method.
size_t | calculateSize (void) const
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
virtual void | queueFireBackgroundLoadingComplete (void)
| Queue the firing of background loading complete event.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Protected Attributes

SkeletonPtr | mSkeleton
| Pointer back to master Skeleton.
TagPointList | mActiveTagPoints
| Active tag point list.
TagPointList | mFreeTagPoints
| Free tag point list.
unsigned short | mNextTagPointAutoHandle
| TagPoint automatic handles.
SkeletonAnimationBlendMode | mBlendState
BoneList | mBoneList
| Storage of bones, indexed by bone handle.
BoneListByName | mBoneListByName
BoneList | mRootBones
| Pointer to root bones (can now have multiple roots).
unsigned short | mNextAutoHandle
| Bone automatic handles.
BoneSet | mManualBones
| Manual bones.
bool | mManualBonesDirty
| Manual bones dirty?
AnimationList | mAnimationsList
LinkedSkeletonAnimSourceList | mLinkedSkeletonAnimSourceList
| List of references to other skeletons to use animations from.
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
volatile LoadingState | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| Mutex to cover the status of loading The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
ListenerList | mListenerList
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).

## Static Protected Attributes

static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Detailed Description

A SkeletonInstance is a single instance of a Skeleton used by a world object.

Remarks:
  The difference between a Skeleton and a SkeletonInstance is that the Skeleton is the 'master' version much like Mesh is a 'master' version of Entity. Many SkeletonInstance objects can be based on a single Skeleton, and are copies of it when created. Any changes made to this are not reflected in the master copy. The exception is animations; these are shared on the Skeleton itself and may not be modified here.

Definition at line 47 of file OgreSkeletonInstance.h.

## Member Typedef Documentation

typedef std::map<String, Animation*> Ogre::Skeleton::AnimationList`[protected, inherited]`

| Storage of animations, lookup by name. Definition at line 419 of file OgreSkeleton.h.

typedef std::vector<ushort> Ogre::Skeleton::BoneHandleMap`[inherited]`

| Map to translate bone handle from one skeleton to another skeleton. Definition at line 345 of file OgreSkeleton.h.

typedef VectorIterator<BoneList> Ogre::Skeleton::BoneIterator`[inherited]`

| Definition at line 172 of file OgreSkeleton.h.

typedef std::vector<Bone*> Ogre::Skeleton::BoneList`[inherited]`

| Definition at line 171 of file OgreSkeleton.h.

typedef std::map<String, Bone*> Ogre::Skeleton::BoneListByName`[protected, inherited]`

| Lookup by bone name. Definition at line 403 of file OgreSkeleton.h.

typedef std::set<Bone*> Ogre::Skeleton::BoneSet`[protected, inherited]`

| Definition at line 411 of file OgreSkeleton.h.

typedef ConstVectorIterator<LinkedSkeletonAnimSourceList> Ogre::Skeleton::LinkedSkeletonAnimSourceIterator`[inherited]`

| Definition at line 329 of file OgreSkeleton.h.

typedef std::vector<LinkedSkeletonAnimationSource> Ogre::Skeleton::LinkedSkeletonAnimSourceList`[inherited]`

| Definition at line 327 of file OgreSkeleton.h.

typedef std::list<Listener*> Ogre::Resource::ListenerList`[protected, inherited]`

| Definition at line 131 of file OgreResource.h.

typedef std::list<TagPoint*> Ogre::SkeletonInstance::TagPointList`[protected]`

| Definition at line 118 of file OgreSkeletonInstance.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

Enum identifying the loading state of the resource.

Enumeration values:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.

Definition at line 96 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::SkeletonInstance::SkeletonInstance | ( | const SkeletonPtr & | masterCopy | ) |

| Constructor, don't call directly, this will be created automatically when you create an Entity based on a skeletally animated Mesh.

Ogre::SkeletonInstance::~SkeletonInstance | ( |  | ) |

## Member Function Documentation

virtual void Ogre::Skeleton::_buildMapBoneByHandle | ( | const Skeleton * | source,
|  | BoneHandleMap & | boneHandleMap
| ) | const`[virtual, inherited]`

Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.

Remarks:
  Identically bones are determine by handle.

virtual void Ogre::Skeleton::_buildMapBoneByName | ( | const Skeleton * | source,
|  | BoneHandleMap & | boneHandleMap
| ) | const`[virtual, inherited]`

Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.

Remarks:
  Identically bones are determine by name.

void Ogre::Skeleton::_dumpContents | ( | const String & | filename | ) | `[protected, inherited]`

| Debugging method.

virtual void Ogre::Resource::_fireBackgroundLoadingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of background loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Animation* Ogre::SkeletonInstance::_getAnimationImpl | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = `0`
| ) | const`[virtual]`

| Internal accessor for animations (returns null if animation does not exist). Reimplemented from Ogre::Skeleton.

virtual void Ogre::Skeleton::_getBoneMatrices | ( | Matrix4 * | pMatrices | ) | `[virtual, inherited]`

Populates the passed in array with the bone matrices based on the current position.

Remarks:
  Internal use only. The array pointed to by the passed in pointer must be at least as large as the number of bones. Assumes animation has already been updated.

void Ogre::SkeletonInstance::_initAnimationState | ( | AnimationStateSet * | animSet | ) | `[virtual]`

Remarks:
  Only recommended for use inside the engine, not by applications.

Reimplemented from Ogre::Skeleton.

virtual void Ogre::Skeleton::_mergeSkeletonAnimations | ( | const Skeleton * | source,
|  | const BoneHandleMap & | boneHandleMap,
|  | const StringVector & | animations = `StringVector()`
| ) | `[virtual, inherited]`

Merge animations from another Skeleton object into this skeleton.

Remarks:
  This function allow merge two structures compatible skeletons. The 'compatible' here means identically bones will have same hierarchy, but skeletons are not necessary to have same number of bones (if number bones of source skeleton's more than this skeleton, they will copied as is, except that duplicate names are unallowed; and in the case of bones missing in source skeleton, nothing happen for those bones).

  There are also unnecessary to have same binding poses, this function will adjust keyframes of the source skeleton to match this skeleton automatically.

  It's useful for export skeleton animations seperately. i.e. export mesh and 'master' skeleton at the same time, and then other animations will export seperately (even if used completely difference binding pose), finally, merge seperately exported animations into 'master' skeleton.

Parameters:

  | source | Pointer to source skeleton. It'll keep unmodified.
  | boneHandleMap | A map to translate identically bone's handle from source skeleton to this skeleton. If mapped bone handle doesn't exists in this skeleton, it'll created. You can populate bone handle map manually, or use predefined functions build bone handle map for you. (

See also:
  _buildMapBoneByHandle, _buildMapBoneByName)

Parameters:

  | animations | A list name of animations to merge, if empty, all animations of source skeleton are used to merge. Note that the animation names must not presented in this skeleton, and will NOT pick up animations in linked skeletons (

See also:
  addLinkedSkeletonAnimationSource).

virtual void Ogre::Skeleton::_notifyManualBonesDirty | ( | void |  | ) | `[virtual, inherited]`

| Internal method for marking the manual bones as dirty.

virtual void Ogre::Skeleton::_notifyManualBoneStateChange | ( | Bone * | bone | ) | `[virtual, inherited]`

| Internal method for notifying that a bone is manual.

void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[inherited]`

| Notify this resource of it's origin. Definition at line 358 of file OgreResource.h.

void Ogre::SkeletonInstance::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) | `[virtual]`

Remarks:
  Only recommended for use inside the engine, not by applications.

Reimplemented from Ogre::Skeleton.

virtual void Ogre::Skeleton::_updateTransforms | ( | void |  | ) | `[virtual, inherited]`

| Updates all the derived transforms in the skeleton.

void Ogre::SkeletonInstance::addLinkedSkeletonAnimationSource | ( | const String & | skelName,
|  | Real | scale = `1.0f`
| ) | `[virtual]`

Remarks:
  If you have skeletons of identical structure (that means identically named bones with identical handles, and with the same hierarchy), but slightly different proportions or binding poses, you can re-use animations from one in the other. Because animations are actually stored as changes to bones from their bind positions, it's possible to use the same animation data for different skeletons, provided the skeletal structure matches and the 'deltas' stored in the keyframes apply equally well to the other skeletons bind position (so they must be roughly similar, but don't have to be identical). You can use the 'scale' option to adjust the translation and scale keyframes where there are large differences in size between the skeletons.

Note:
  This method takes a skeleton name, rather than a more specific animation name, for two reasons; firstly it allows some validation of compatibility of skeletal structure, and secondly skeletons are the unit of loading. Linking a skeleton to another in this way means that the linkee will be prevented from being destroyed until the linker is destroyed.

You cannot set up cyclic relationships, e.g. SkeletonA uses SkeletonB's animations, and SkeletonB uses SkeletonA's animations. This is because it would set up a circular dependency which would prevent proper unloading - make one of the skeletons the 'master' in this case.

Parameters:

  | skelName | Name of the skeleton to link animations from. This skeleton will be loaded immediately if this skeleton is already loaded, otherwise it will be loaded when this skeleton is.
  | scale | A scale factor to apply to translation and scaling elements of the keyframes in the other skeleton when applying the animations to this one. Compensates for skeleton size differences.

Reimplemented from Ogre::Skeleton.

void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[inherited]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

size_t Ogre::Skeleton::calculateSize | ( | void |  | ) | const`[protected, virtual, inherited]`

| Implements Ogre::Resource. Definition at line 443 of file OgreSkeleton.h.

void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[inherited]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes.

void Ogre::SkeletonInstance::cloneBoneAndChildren | ( | Bone * | source,
|  | Bone * | parent
| ) | `[protected]`

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs.

Animation* Ogre::SkeletonInstance::createAnimation | ( | const String & | name,
|  | Real | length
| ) | `[virtual]`

Creates a new Animation object for animating this skeleton.

Remarks:
  This method updates the reference skeleton, not just this instance!

Parameters:

  | name | The name of this animation
  | length | The length of the animation in seconds

Reimplemented from Ogre::Skeleton.

virtual Bone* Ogre::Skeleton::createBone | ( | const String & | name,
|  | unsigned short | handle
| ) | `[virtual, inherited]`

Creates a brand new Bone owned by this Skeleton.

Remarks:
  This method creates an unattached new Bone for this skeleton and assigns it a specific name and handle. Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created the root bone.

Parameters:

  | name | The name to give to this new bone - must be unique within this skeleton.
  | handle | The handle to give to this new bone - must be unique within this skeleton.

virtual Bone* Ogre::Skeleton::createBone | ( | const String & | name | ) | `[virtual, inherited]`

Creates a brand new Bone owned by this Skeleton.

Remarks:
  This method creates an unattached new Bone for this skeleton and assigns it a specific name.Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created the root bone.

Parameters:

  | name | The name to give to this new bone - must be unique within this skeleton. Note that the way OGRE looks up bones is via a numeric handle, so if you name a Bone this way it will be given an automatic sequential handle. The name is just for your convenience, although it is recommended that you only use the handle to retrieve the bone in performance-critical code.

virtual Bone* Ogre::Skeleton::createBone | ( | unsigned short | handle | ) | `[virtual, inherited]`

Creates a brand new Bone owned by this Skeleton.

Remarks:
  This method creates an unattached new Bone for this skeleton and assigns it a specific handle. Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created a root bone.

Parameters:

  | handle | The handle to give to this new bone - must be unique within this skeleton. You should also ensure that all bone handles are eventually contiguous (this is to simplify their compilation into an indexed array of transformation matrices). For this reason it is advised that you use the simpler createBone method which automatically assigns a sequential handle starting from 0.

virtual Bone* Ogre::Skeleton::createBone | ( | void |  | ) | `[virtual, inherited]`

Creates a brand new Bone owned by this Skeleton.

Remarks:
  This method creates an unattached new Bone for this skeleton. Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created the root bone.

  Note that this method automatically generates a handle for the bone, which you can retrieve using Bone::getHandle. If you wish the new Bone to have a specific handle, use the alternate form of this method which takes a handle as a parameter, although you should note the restrictions.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

TagPoint* Ogre::SkeletonInstance::createTagPointOnBone | ( | Bone * | bone,
|  | const Quaternion & | offsetOrientation = `Quaternion::IDENTITY`,
|  | const Vector3 & | offsetPosition = `Vector3::ZERO`
| ) |

| Creates a TagPoint ready to be attached to a bone.

void Ogre::Skeleton::deriveRootBone | ( | void |  | ) | const`[protected, inherited]`

Internal method which parses the bones to derive the root bone.

Remarks:
  Must be const because called in getRootBone but mRootBone is mutable since lazy-updated.

void Ogre::Resource::escalateLoading | ( |  | ) | `[inherited]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::SkeletonInstance::freeTagPoint | ( | TagPoint * | tagPoint | ) |

| Frees a TagPoint that already attached to a bone.

Animation* Ogre::SkeletonInstance::getAnimation | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = `0`
| ) | const`[virtual]`

| Returns the named Animation object. Reimplemented from Ogre::Skeleton.

Animation* Ogre::SkeletonInstance::getAnimation | ( | unsigned short | index | ) | const`[virtual]`

| Gets a single animation by index. Reimplemented from Ogre::Skeleton.

virtual SkeletonAnimationBlendMode Ogre::Skeleton::getBlendMode | ( |  | ) | const`[virtual, inherited]`

| Gets the animation blending mode which this skeleton will use.

virtual Bone* Ogre::Skeleton::getBone | ( | const String & | name | ) | const`[virtual, inherited]`

| Gets a bone by it's name.

virtual Bone* Ogre::Skeleton::getBone | ( | unsigned short | handle | ) | const`[virtual, inherited]`

| Gets a bone by it's handle.

virtual BoneIterator Ogre::Skeleton::getBoneIterator | ( | void |  | ) | `[virtual, inherited]`

| Get an iterator over all the bones in the skeleton.

ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[inherited]`

| Gets the manager which created this resource. Definition at line 349 of file OgreResource.h.

const String& Ogre::SkeletonInstance::getGroup | ( | void |  | ) |

| Reimplemented from Ogre::Resource.

ResourceHandle Ogre::SkeletonInstance::getHandle | ( | void |  | ) | const

| Reimplemented from Ogre::Resource.

LinkedSkeletonAnimSourceIterator Ogre::SkeletonInstance::getLinkedSkeletonAnimationSourceIterator | ( | void |  | ) | const`[virtual]`

| Reimplemented from Ogre::Skeleton.

LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[inherited]`

| Returns the current loading state. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 286 of file OgreResource.h.

virtual bool Ogre::Skeleton::getManualBonesDirty | ( | void |  | ) | const`[virtual, inherited]`

| Have manual bones been modified since the skeleton was last updated? Definition at line 340 of file OgreSkeleton.h.

const String& Ogre::SkeletonInstance::getName | ( | void |  | ) | const

| Reimplemented from Ogre::Resource.

unsigned short Ogre::SkeletonInstance::getNumAnimations | ( | void |  | ) | const`[virtual]`

| Gets the number of animations on this skeleton. Reimplemented from Ogre::Skeleton.

virtual unsigned short Ogre::Skeleton::getNumBones | ( | void |  | ) | const`[virtual, inherited]`

| Returns the number of bones in this skeleton.

const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[inherited]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 356 of file OgreResource.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 213 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual Bone* Ogre::Skeleton::getRootBone | ( | void |  | ) | const`[virtual, inherited]`

Gets the root bone of the skeleton: deprecated in favour of getRootBoneIterator.

Remarks:
  The system derives the root bone the first time you ask for it. The root bone is the only bone in the skeleton which has no parent. The system locates it by taking the first bone in the list and going up the bone tree until there are no more parents, and saves this top bone as the root. If you are building the skeleton manually using createBone then you must ensure there is only one bone which is not a child of another bone, otherwise your skeleton will not work properly. If you use createBone only once, and then use Bone::createChild from then on, then inherently the first bone you create will by default be the root.

virtual BoneIterator Ogre::Skeleton::getRootBoneIterator | ( | void |  | ) | `[virtual, inherited]`

| Get an iterator over the root bones in the skeleton, ie those with no parents.

size_t Ogre::Resource::getSize | ( | void |  | ) | const`[inherited]`

| Retrieves info about the size of the resource. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 247 of file OgreResource.h.

virtual bool Ogre::Skeleton::hasAnimation | ( | const String & | name | ) | `[virtual, inherited]`

| Returns whether this skeleton contains the named animation.

virtual bool Ogre::Skeleton::hasManualBones | ( | void |  | ) | const`[virtual, inherited]`

| Are there any manually controlled bones? Definition at line 342 of file OgreSkeleton.h.

bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[inherited]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 303 of file OgreResource.h.

bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource has been loaded, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 270 of file OgreResource.h.

LoadingState Ogre::Resource::isLoading | ( |  | ) | const`[inherited]`

| Returns whether the resource is currently in the process of background loading. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 279 of file OgreResource.h.

bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[inherited]`

| Is this resource manually loaded? Definition at line 235 of file OgreResource.h.

bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource is reloadable, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 228 of file OgreResource.h.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::SkeletonInstance::loadImpl | ( | void |  | ) | `[protected, virtual]`

| Overridden from Skeleton. Reimplemented from Ogre::Skeleton.

virtual void Ogre::Skeleton::optimiseAllAnimations | ( | bool | preservingIdentityNodeTracks = `false` | ) | `[virtual, inherited]`

Optimise all of this skeleton's animations.

See also:
  Animation::optimise

Parameters:

  | preservingIdentityNodeTracks | If true, don't destroy identity node tracks.

virtual void Ogre::Resource::postLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented in Ogre::Mesh.

Definition at line 156 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 166 of file OgreResource.h.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 149 of file OgreResource.h.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 161 of file OgreResource.h.

virtual void Ogre::Resource::queueFireBackgroundLoadingComplete | ( | void |  | ) | `[protected, virtual, inherited]`

| Queue the firing of background loading complete event.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::SkeletonInstance::removeAllLinkedSkeletonAnimationSources | ( | void |  | ) | `[virtual]`

| Reimplemented from Ogre::Skeleton.

void Ogre::SkeletonInstance::removeAnimation | ( | const String & | name | ) | `[virtual]`

Removes an Animation from this skeleton.

Remarks:
  This method updates the reference skeleton, not just this instance!

Reimplemented from Ogre::Skeleton.

void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[inherited]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Skeleton::reset | ( | bool | resetManualBones = `false` | ) | `[virtual, inherited]`

Resets the position and orientation of all bones in this skeleton to their original binding position.

Remarks:
  A skeleton is bound to a mesh in a binding pose. Bone positions are then modified from this position during animation. This method returns all the bones to their original position and orientation.

Parameters:

  | resetManualBones | If set to true, causes the state of manual bones to be reset too, which is normally not done to allow the manual state to persist even when keyframe animation is applied.

virtual void Ogre::Skeleton::setAnimationState | ( | const AnimationStateSet & | animSet | ) | `[virtual, inherited]`

Changes the state of the skeleton to reflect the application of the passed in collection of animations.

Remarks:
  Animating a skeleton involves both interpolating between keyframes of a specific animation, and blending between the animations themselves. Calling this method sets the state of the skeleton so that it reflects the combination of all the passed in animations, at the time index specified for each, using the weights specified. Note that the weights between animations do not have to sum to 1.0, because some animations may affect only subsets of the skeleton. If the weights exceed 1.0 for the same area of the skeleton, the movement will just be exaggerated.

Parameters:

void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[inherited]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 313 of file OgreResource.h.

virtual void Ogre::Skeleton::setBindingPose | ( | void |  | ) | `[virtual, inherited]`

| Sets the current position / orientation to be the 'binding pose' ie the layout in which bones were originally bound to a mesh.

virtual void Ogre::Skeleton::setBlendMode | ( | SkeletonAnimationBlendMode | state | ) | `[virtual, inherited]`

| Sets the animation blending mode this skeleton will use.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual, inherited]`

| 'Touches' the resource to indicate it has been used. Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

| Unloads the resource; this is not permanent, the resource can be reloaded later if required. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::SkeletonInstance::unloadImpl | ( | void |  | ) | `[protected, virtual]`

| Overridden from Skeleton. Reimplemented from Ogre::Skeleton.

## Member Data Documentation

TagPointList Ogre::SkeletonInstance::mActiveTagPoints`[protected]`

Active tag point list.

Remarks:
  This is a linked list of pointers to actived tag point

  This allows very fast instertions and deletions from anywhere in the list to activate / deactivate tag points (required for weapon / equip systems etc) as well as resuse of TagPoint instances without construction & destruction which avoids memory thrashing.

Definition at line 128 of file OgreSkeletonInstance.h.

AnimationList Ogre::Skeleton::mAnimationsList`[protected, inherited]`

| Definition at line 420 of file OgreSkeleton.h.

SkeletonAnimationBlendMode Ogre::Skeleton::mBlendState`[protected, inherited]`

| Definition at line 399 of file OgreSkeleton.h.

BoneList Ogre::Skeleton::mBoneList`[protected, inherited]`

| Storage of bones, indexed by bone handle. Definition at line 401 of file OgreSkeleton.h.

BoneListByName Ogre::Skeleton::mBoneListByName`[protected, inherited]`

| Definition at line 404 of file OgreSkeleton.h.

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

| Creator. Definition at line 109 of file OgreResource.h.

TagPointList Ogre::SkeletonInstance::mFreeTagPoints`[protected]`

Free tag point list.

Remarks:
  This contains a list of the tag points free for use as new instances as required by the set. When a TagPoint instances are deactived, there will are referenced on this list. As they get used this list reduces, as they get released back to to the set they get added back to the list.

Definition at line 137 of file OgreSkeletonInstance.h.

String Ogre::Resource::mGroup`[protected, inherited]`

| The name of the resource group. Definition at line 113 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

| Numeric handle for more efficient look up than name. Definition at line 115 of file OgreResource.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

| Is this resource going to be background loaded? Only applicable for multithreaded. Definition at line 119 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

| Is this file manually loaded? Definition at line 125 of file OgreResource.h.

LinkedSkeletonAnimSourceList Ogre::Skeleton::mLinkedSkeletonAnimSourceList`[mutable, protected, inherited]`

| List of references to other skeletons to use animations from. Definition at line 423 of file OgreSkeleton.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

| Definition at line 132 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

| Optional manual loader; if provided, data is loaded from here instead of a file. Definition at line 129 of file OgreResource.h.

volatile LoadingState Ogre::Resource::mLoadingState`[protected, inherited]`

| Is the resource currently loaded? Definition at line 117 of file OgreResource.h.

BoneSet Ogre::Skeleton::mManualBones`[protected, inherited]`

| Manual bones. Definition at line 413 of file OgreSkeleton.h.

bool Ogre::Skeleton::mManualBonesDirty`[protected, inherited]`

| Manual bones dirty? Definition at line 415 of file OgreSkeleton.h.

String Ogre::Resource::mName`[protected, inherited]`

| Unique name of the resource. Definition at line 111 of file OgreResource.h.

unsigned short Ogre::Skeleton::mNextAutoHandle`[protected, inherited]`

| Bone automatic handles. Definition at line 410 of file OgreSkeleton.h.

unsigned short Ogre::SkeletonInstance::mNextTagPointAutoHandle`[protected]`

| TagPoint automatic handles. Definition at line 140 of file OgreSkeletonInstance.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

| Origin of this resource (e.g. script name) - optional. Definition at line 127 of file OgreResource.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 164 of file OgreStringInterface.h.

BoneList Ogre::Skeleton::mRootBones`[mutable, protected, inherited]`

| Pointer to root bones (can now have multiple roots). Definition at line 408 of file OgreSkeleton.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

| Dictionary of parameters. Definition at line 161 of file OgreStringInterface.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

| Mutex to cover the status of loading The size of the resource in bytes. Definition at line 123 of file OgreResource.h.

SkeletonPtr Ogre::SkeletonInstance::mSkeleton`[protected]`

| Pointer back to master Skeleton. Definition at line 116 of file OgreSkeletonInstance.h.

The documentation for this class was generated from the following file:

- OgreSkeletonInstance.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:02 2008